#!/usr/bin/perl

#Initialise some variables
$block="";
$bus=-1;
$device=-1;

# Check if we can read the 
if (-r "/proc/bus/usb/devices") {
  # open devices list and dump it to $block
  open INPUT, "/proc/bus/usb/devices";
  $block.=$line while ($line = <INPUT>);
  close INPUT;

  # find listing for each device and go through them one by one
  while ($block =~ m~(T:.*?\nE:)~sgi) {
    $dev=$1;

    # is this a Matrix Orbital MX2/3?  If so, grab the other details from this device
    if (($dev =~ m"Manufacturer=Matrix Orbital"si) && ($dev =~ m~Product=MX2/MX3~i)) {
      $bus    = $1 if ($dev =~ m~Bus=0?([0-9]+)\s+~);
      $device = $1 if ($dev =~ m~Dev#=\s*([0-9]+)\s+~);
    }
    # found an MX2/3?  Might as well stop the loop.
    last if ($bus > -1);
  }

  # if details are found, print it
  if (($bus > -1) && ($device > -1)) {
    print "Matrix Orbital MX2/3 found on Bus$bus Device$device!\n";
  } else {
    # Otherwise, report a failure
    die("Matrix Orbital MX2/3 not found");
  }

# If the device file *couldn't* be accessed at the start, complain.
} else {
 die("Couldn't read device list");
}
